
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>轻松python之文件专题-关于行的操作 / 憋错料</title>

    <meta name="description" content="轻松python之文件专题-关于行的操作 1.计算文本行数 最常用的就是readlines &gt;&gt;&gt; handler=open('input_file.txt') &gt;&gt;&gt; lines=handler.readlines () &gt;&gt;&gt; lenOfFile=len(lines) 但是如果是一个超过100m的文本文件,上面的方法基本确定是会很慢,甚至运行不了 因此,我们需要其他的方法 1)使用循环计数,引入enumerate方法 &gt;&gt;&gt; count=-1 &gt;&gt;& ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">轻松python之文件专题-关于行的操作</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>1.计算文本行数</p>
<p>最常用的就是readlines</p>
<pre>&gt;&gt;&gt; handler=open(&#039;input_file.txt&#039;)
&gt;&gt;&gt; lines=handler.readlines ()
&gt;&gt;&gt; lenOfFile=len(lines)</pre>
<p>但是如果是一个超过100m的文本文件，上面的方法基本确定是会很慢，甚至运行不了</p>
<p>因此，我们需要其他的方法</p>
<p>1）使用循环计数，引入enumerate方法</p>
<pre>&gt;&gt;&gt; count=-1
&gt;&gt;&gt; for index,line in enumerate(open (&#039;input_file.txt&#039; , &#039;rU&#039; )):
	count+=1

&gt;&gt;&gt; count
5
&gt;&gt;&gt; </pre>
<p>注意：count是从-1开始</p>
<p>2）如果再考虑到性能的问题，我们使用其他的方法</p>
<p>因为文本文件一般已/n为换行符，所以，我们可以载入一部分文本，计算里面的换行符是多少</p>
<pre>&gt;&gt;&gt; import codecs
&gt;&gt;&gt; count = 0
&gt;&gt;&gt; the_file = codecs.open(&#039;input_file.txt&#039;, &#039;rb&#039;, &#039;utf-8&#039;)
&gt;&gt;&gt; try:
	while (True):
		    buffer = the_file.read(8192*1024)
		    if not buffer:break
		    count += buffer.count(&#039;\n&#039;)
finally:the_file.close()

&gt;&gt;&gt; count
5
&gt;&gt;&gt; </pre>
<p>2.读取某一行（以小文本为例）</p>
<p>我们一般会想到循环，然后到某一行停下来，打印</p>
<pre>&gt;&gt;&gt; handler=open(&#039;input_file.txt&#039;)
&gt;&gt;&gt; lines=handler.readlines ()
&gt;&gt;&gt; lenOfFile=len(lines)
&gt;&gt;&gt; for x in range(lenOfFile):
	if x==3:print(lines[x])

dff

&gt;&gt;&gt; </pre>
<p>上面的例子我们可以封装成一个方法：</p>
<pre>&gt;&gt;&gt; def readTheXLineOfFile(path,lineNum):
	handler=open(path)
	try:
		lines=handler.readlines()
		for x in range(len(lines)):
			if x==lineNum:
				print(lines[lineNum])
	finally:handler.close ()

&gt;&gt;&gt; readTheXLineOfFile(&#039;input_file.txt&#039;,3)
dff

&gt;&gt;&gt; </pre>
<p>但是我们有更加快捷的方法：</p>
<pre>&gt;&gt;&gt; import linecache
&gt;&gt;&gt; theLine=linecache.getline
&gt;&gt;&gt; theLine=linecache.getline (&#039;input_file.txt&#039;,3)
&gt;&gt;&gt; theLine
&#039;bd\n&#039;
&gt;&gt;&gt; theLine=linecache.getline (&#039;input_file.txt&#039;,4)
&gt;&gt;&gt; theLine
&#039;dff\n&#039;
&gt;&gt;&gt; </pre>
<p>我们引入linecache，通过getline的方法得到某一行，但是需要注意：它的行数是从0开始的</p>
<p>就说到这里，谢谢大家</p>
<p>------------------------------------------------------------------</p>
<p><a href="http://blog.csdn.net/raylee2007/article/details/47376729" rel="external nofollow noreferrer">点击跳转零基础学python-目录</a></p>
<p>版权声明：本文为博主原创文章，未经博主允许不得转载。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-10 02:06:21 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/python/" title="python">python</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>轻松python之文件专题-关于行的操作的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzBdgdM.html" rel="bookmark">轻松python之文件专题-关于zip文件的一些操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				场景: zip文件的操作,包括增删改查 1.zip的创建,并在zip包里面创建一个文件 &gt;&gt;&gt; import zipfile &gt;&gt;&gt; handler=open('temp_zip.zip','w') &gt;&gt;&gt; handler.close () &gt;&gt;&gt; z=zipfile.ZipFile ('c:/Python34/temp_zip.zip','w') &gt;&gt;&gt; z.writestr('hello.py','def f()			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AZa8ZM.html" rel="bookmark">python 读取文件指定某行</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				#encoding=utf-8   #从文件中读取某一行 linecache.checkcache可以刷新cache ,linecache可以缓存某一行的信息            import linecache    line = linecache.getline(r'1.txt', 2)   print line #如果文件比较大 使用下面 def getline(thefilepath,line_num):     if line_num &lt; 1 :return ''     for 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0l5JBN3.html" rel="bookmark">python之文件和素材</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				11.1 打开文件 open函数 open(name[,mode[,buffering]]) &gt;&gt;&gt;f = open(r'C:\text\somefile.txt') 11.1.1 文件模式 open函数中模式参数的常用值 'r' 读模式 'w' 写模式 'a' 追加模式 'b' 二进制模式 '+' 读/写模式 通过在模式参数中使用U参数能够在打开文件时使用通用的换行符支持模式,在这种模式下,所有的换行符/字符串(\r\n,\r或者是\n)都被转换成\n,而不用考虑运行的平台. 11.1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lXxro0.html" rel="bookmark">python声明文件编码，必须在文件的第一行或第二行</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				#coding=utf-8和# -*- coding: utf-8 -*-的作用 – 指定文件编码类型 注意的两点: 1.声明必须在文件的第一行或第二行: 2.coding后面必须紧跟冒号或等号,#coding : utf-8是错的. 例: 声明编码前有字符串 1 '''testing user longin''' 2 #coding:utf-8 3 4 print u'''登录相关的测试''' 或 声明编码位于第三行 1 #'test' 2 3 #coding:utf-8 4 5 print			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/V0bAlwM.html" rel="bookmark">python读取文件的前几行</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				文件内容rolling.txt: There's a fire starting in my heart 我怒火中烧 Reaching a fever pitch and it's bringing me out the dark 熊熊烈焰带我走出黑暗 Finally, I can see you crystal clear 最终 我将你看得一清二楚 Go ahead and sell me out and I'll lay your ship bare 去吧 出卖我 我会让你一无全部 See			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0nyeDVM.html" rel="bookmark">python之从文件中按行读取数据</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				#!/usr/bin/env python3 # -*- coding: utf-8 -*- __author__ = 'jiangwenwen' # 从文件中按行读取数据 file = open(&quot;D:\坚果云\我的坚果云\\2019年计划.txt&quot;) while 1: lines = file.readlines(100000) if not lines: break for line in lines: print(line) 原文地址:https://www.cnblogs.c			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/NMy8ja4.html" rel="bookmark">Python学习-文件操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				打开和关闭文件: Python 提供了必要的函数和方法进行默认情况下的文件基本操作. open 函数 你必须先用Python内置的open()函数打开一个文件,创建一个file对象,相关的方法才可以调用它进行读写. 语法: file object = open(file_name [, access_mode][, buffering]) 各个参数的细节如下: ①file_name:file_name变量是一个包含了你要访问的文件名称的字符串值. ②access_mode:access_mode			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/9MBmXq4.html" rel="bookmark">Python读写文件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Python读写文件1.open使用open打开文件后一定要记得调用文件对象的close()方法.比如可以用try/finally语句来确保最后能关闭文件. file_object = open('thefile.txt')try:     all_the_text = file_object.read( )finally:     file_object.close( ) 注:不能把open语句放在try块里,因为当打开文件出现异常时,文件对象file_object无法执行close()方法.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/g41BZkM.html" rel="bookmark">Python对文件的操作&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.文件对象 我理解的文件对象就是一个接口,通过这个接口对文件进行相关操作. &lt;Python 核心编程&gt;上说的很晦涩,这里没有深刻理解到,希望有人能解释给我听. &gt;&gt;&gt; f = open('demo.txt','r') &gt;&gt;&gt; f &lt;open file 'demo.txt', mode 'r' at 0x00CCCEC0&gt; &gt;&gt;&gt; type(f) &lt;type 'file'&gt; 二.相关函数 [1].内建函数:open(			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q0xpEL0.html" rel="bookmark" class="title">Python-基础知识-列表list和元组tuple</a>
					<div>
						列表List 创建列表: &gt;&gt;&gt; week = [&quot;Sun&quot;,&quot;Mon&quot;,&quot;Tue&quot;,&quot;Wen&quot;,&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4peqBKM.html" rel="bookmark" class="title">corsetjiedu</a>
					<div>
						Corset: enabling differential gene expression analysis for de novo assembled transcriptomes 背景: 转录组测 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ORNgr0.html" rel="bookmark" class="title">Delphi中多线程的技巧</a>
					<div>
						创建线程 MsgThread := TMsgThread.Create(False) ; //创建并执行线程 MsgThread := TMsgThread.Create(True) ; //创建线程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZbAVg3.html" rel="bookmark" class="title">pickle序列化</a>
					<div>
						#从内存写入到硬盘: import pickle dic={'a':'111','b':'222'} f=open('c:\\pic.pkl','wb') pickle.dump(dic,f) f.c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MV78gQ0.html" rel="bookmark" class="title">Ubuntu 16&period;04 LTS GNOME版本下载</a>
					<div>
						下载地址: http://cdimage.ubuntu.com/ubuntu-gnome/releases/ Ubuntu GNOME发行版本启动已经有三年的时间了,在社区用户对于在稳定可靠的Ubun ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vzNwk3.html" rel="bookmark" class="title">复旦大学附属耳鼻喉医院的某位主任医师不负责任</a>
					<div>
						这是我的真实就诊经历,且听我下面说为啥不建议大家去约这家三甲医院的周末专家门诊.我的就诊目的是想让医生根据我个人的CT结果,来诊断是否严重到要动手术的地步了,结果你知道这位专家,这位三甲医院的主治医生 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RnmyP0.html" rel="bookmark" class="title">学英语《每日一歌》之brave</a>
					<div>
						[每日一歌]今天给大家推荐的是jennifer lopez(詹妮弗·洛佩兹)的一首经典老歌-&lt;Brave&gt;.一首英文&lt;brave&gt;,我个人很喜欢的一首.我不害怕,我很勇敢!时常 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyQLXYM.html" rel="bookmark" class="title">Flexcell 导出Excel 打不开，提示Excel在&OpenCurlyDoubleQuote;XXXX&period;xls&rdquo; &NewLine;中发现不可读取的内容。是否要回复此工作薄的内容？如果信任此工作薄的来源，请点击&OpenCurlyDoubleQuote;是&rdquo;。</a>
					<div>
						我们在项目中应用Flexcell 导出Excel时报错,提示Excel在&quot;XXXX.xls&quot; 中发现不可读取的内容.是否要回复此工作薄的内容?如果信任此工作薄的来源,请点击&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Oynm8M.html" rel="bookmark" class="title">07Mybatis&lowbar;根据前面的做的两个查询联系，做一些小的总结</a>
					<div>
						总结如下: 1.parameterType和resultType 在映射文件中通过parameterType指定输入 参数的类型. 在映射文件中通过resultType指定输出结果的类型. 例如: & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0azKoR3.html" rel="bookmark" class="title">poj 3579</a>
					<div>
						/* 描述: 给定n个数字,求所有两两数字之差的绝对值的中位数. 可知,共有n*(n-1)/2=m个数字. 解析: 因为满足性质——假如对key可以找出&gt;m/2个数字&gt;=key,那么对于任 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZQgdm0.html" rel="bookmark" class="title">数据结构&mdash;&mdash;排序&mdash;&mdash;8种常用排序算法稳定性分析</a>
					<div>
						首先,排序算法的稳定性大家应该都知道,通俗地讲就是能保证排序前2个相等的数其在序列的前后位置顺序和排序后它们两个的前后位置顺序相同.在简单形式化一下,如果Ai = Aj, Ai原来在位置前,排序后Ai ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bKOEY3.html" rel="bookmark" class="title">Andriod APK 文件结构详解</a>
					<div>
						APK文件结构 APK文件实际是一个zip压缩包,可以通过解压缩工具解开. 下面是用解压缩工具解开的APK包的结构: |-- AndroidManifest.xml |-- META-INF | |- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AavJv4.html" rel="bookmark" class="title">&lbrack;RxJS&rsqb; Filtering operators&colon; skipWhile and skipUntil</a>
					<div>
						After takeUntil() and takeWhile() function, let's have a look on skipWhile() and skilUntil() functio ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoRlAB4.html" rel="bookmark" class="title">美联舍彩装膜加盟初步了解</a>
					<div>
						2013年全国食品安全宣传周启动仪式暨第五届中国食品安全论坛6月17日在京举行.公安部副部长黄招商网出席并致辞.他强调,食品安全是事关民生福祉.事关和谐稳定的重大问题,需要各方面同心携手.共同治理.各 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzX21q3.html" rel="bookmark" class="title">鸟哥的Linux私房菜&mdash;&mdash;第十五章：正规表示法</a>
					<div>
						视频链接 土豆: B站: 本章讲的是 目录如下 1. 前言:2. 基础正规表示法:2.1 以 grep 撷取字符串 (grep -iv  i是忽略大小写,v是反向选择显示没有搜寻字符串的 '搜寻字符串 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47oXy14.html" rel="bookmark" class="title">Elasticsearch集群监控工具bigdesk插件安装</a>
					<div>
						bigdesk是elasticsearch的一个集群监控工具,可以通过它来查看es集群的各种状态,如:cpu.内存使用情况,索引数据.搜索情况,http连接数等. 项目git地址: https://g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoXRlQ0.html" rel="bookmark" class="title">Python之路【第十八篇】Django小项目简单BBS论坛部分内容知识点</a>
					<div>
						开发一个简单的BBS论坛 项目需求: 1 整体参考“抽屉新热榜” + “虎嗅网” 2 实现不同论坛版块 3 帖子列表展示 4 帖子评论数.点赞数展示 5 在线用户展示 6 允许登录用户发贴.评论.点赞 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xX7PL0.html" rel="bookmark" class="title">DataGridView中实现checkbox全选的自定义控件</a>
					<div>
						在DataGridView中实现Checkbox的全选的方法就是在列头画一个checkbox, 并给其一个事件. 这个之前很多blog都有写, 这里就不多废话了,  codeproject上面有示例代 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kwegP0.html" rel="bookmark" class="title">电话 SMS 邮件 网页 AppStore</a>
					<div>
						//调用safar打开网页 [[UIApplication sharedApplication] openURL:[NSURL URLWithString:@&quot;http://www.cnbl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzyAWl4.html" rel="bookmark" class="title">《学习opencv》笔记&mdash;&mdash;基本数据结构，CvMat，矩阵访问</a>
					<div>
						    老板让让做一个东东,输入端要用到opencv顺便就来学习一下.买了本书&lt;学习opencv&gt;翻来一看,opencv1.0,去官网上一看,opencv2.49,瞬间有种蛋碎的赶脚.看着 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
